---
layout: docs30-cn
title: 概述
categories: docs
permalink: /cn/docs30/index.html
---

欢迎来到 Apache Kylin™
------------  
> Analytical Data Warehouse for Big Data

Apache Kylin™是一个开源的、分布式的分析型数据仓库，提供Hadoop之上的SQL查询接口及多维分析（OLAP）能力以支持超大规模数据，最初由eBay Inc.开发并贡献至开源社区。

查看旧版本文档: 
* [v2.4 document](/cn/docs24/)
* [v2.3 document](/cn/docs23/)
* [归档](/archive/)

安装
------------  
1. [安装指南](install/index.html)
2. [Kylin 配置](install/configuration.html)
3. [集群模式部署](install/kylin_cluster.html)
4. [高级配置](install/advance_settings.html)
5. [用 Docker 运行 Kylin](install/kylin_docker.html)
6. [在 AWS EMR 上安装 Kylin](install/kylin_aws_emr.html)

教程
------------  
1. [样例 Cube 快速入门](tutorial/kylin_sample.html)
2. [Web 界面](tutorial/web.html)
3. [Cube 创建](tutorial/create_cube.html)
4. [Cube 构建和 Job 监控](tutorial/cube_build_job.html)
5. [SQL 快速参考](tutorial/sql_reference.html)
6. [用 Kafka 流构建 Cube](tutorial/cube_streaming.html)
7. [用 Spark 构建 Cube](tutorial/cube_spark.html)
8. [优化 Cube 构建](tutorial/cube_build_performance.html)
9. [查询下压](tutorial/query_pushdown.html)
10. [建立 System Cube](tutorial/setup_systemcube.html)
11. [使用 Cube Planner](tutorial/use_cube_planner.html)
12. [使用 Dashboard](tutorial/use_dashboard.html)
13. [建立 JDBC 数据源](tutorial/setup_jdbc_datasource.html)


工具集成
------------  
1. [ODBC 驱动](tutorial/odbc.html)
2. [JDBC 驱动](howto/howto_jdbc.html)
3. [RESTful API 列表](howto/howto_use_restapi.html)
4. [用 API 构建 Cube](howto/howto_build_cube_with_restapi.html)
5. [MS Excel 及 PowerBI 教程](tutorial/powerbi.html)
6. [Tableau 8](tutorial/tableau.html)
7. [Tableau 9](tutorial/tableau_91.html)
8. [SQuirreL](tutorial/squirrel.html)
9. [Qlik Sense 集成](tutorial/Qlik.html)
10. [Apache Superset](tutorial/superset.html)
11. [Redash](/blog/2018/05/08/redash-kylin-plugin-strikingly/)


帮助
------------  
1. [备份 Kylin 元数据](howto/howto_backup_metadata.html)
2. [清理存储](howto/howto_cleanup_storage.html)






