---
layout: docs30
title: Overview
categories: docs
permalink: /docs30/index.html
---


Welcome to Apache Kylin™: Analytical Data Warehouse for Big Data
------------  

Apache Kylin™ is an open source Distributed Analytical Data Warehouse designed to provide SQL interface and multi-dimensional analysis (OLAP) on Hadoop supporting extremely large datasets.

This is the document for v3.0 with the new feature Real-time OLAP. Document of prior versions: 
* [v2.4 document](/docs24)
* [v2.3 document](/docs23)
* [Archived](/archive/)

Installation & Setup
------------  
1. [Installation Guide](install/index.html)
2. [Configurations](install/configuration.html)
3. [Deploy in cluster mode](install/kylin_cluster.html)
4. [Advanced settings](install/advance_settings.html)
5. [Run Kylin with Docker](install/kylin_docker.html)
6. [Install Kylin on AWS EMR](install/kylin_aws_emr.html)

Tutorial
------------  
1. [Quick Start with Sample Cube](tutorial/kylin_sample.html)
2. [Web Interface](tutorial/web.html)
3. [Cube Wizard](tutorial/create_cube.html)
4. [Cube Build and Job Monitoring](tutorial/cube_build_job.html)
5. [SQL reference](tutorial/sql_reference.html)
6. [Build Cube with Streaming Data (Near real-time)](tutorial/cube_streaming.html)
7. [Real-time OLAP (NEW!)](tutorial/realtime_olap.html)
8. [Build Cube with Spark Engine](tutorial/cube_spark.html)
9. [Cube Build Tuning](tutorial/cube_build_performance.html)
10. [Enable Query Pushdown](tutorial/query_pushdown.html)
11. [Setup System Cube](tutorial/setup_systemcube.html)
12. [Optimize with Cube Planner](tutorial/use_cube_planner.html)
13. [Use System Dashboard](tutorial/use_dashboard.html)
14. [Setup JDBC Data Source](tutorial/setup_jdbc_datasource.html)


Connectivity and APIs
------------  
1. [ODBC driver](tutorial/odbc.html)
2. [JDBC driver](howto/howto_jdbc.html)
3. [RESTful API list](howto/howto_use_restapi.html)
4. [Build cube with RESTful API](howto/howto_build_cube_with_restapi.html)
5. [Connect from MS Excel and PowerBI](tutorial/powerbi.html)
6. [Connect from Tableau 8](tutorial/tableau.html)
7. [Connect from Tableau 9](tutorial/tableau_91.html)
8. [Connect from MicroStrategy](tutorial/microstrategy.html)
9. [Connect from SQuirreL](tutorial/squirrel.html)
10. [Connect from Apache Flink](tutorial/flink.html)
11. [Connect from Apache Spark](tutorial/spark.html)
12. [Connect from Hue](tutorial/hue.html)
13. [Connect from Qlik Sense](tutorial/Qlik.html)
14. [Connect from Apache Superset](tutorial/superset.html)
15. [Connect from Redash](/blog/2018/05/08/redash-kylin-plugin-strikingly/)


Operations
------------  
1. [Backup/restore Kylin metadata](howto/howto_backup_metadata.html)
2. [Cleanup storage](howto/howto_cleanup_storage.html)
3. [Upgrade from old version](howto/howto_upgrade.html)



